clear all; clc;
addpath(genpath('../MVMC_code'));
% dataname = 'WebKB_cornell';
dataname = 'WebKB_texas';
filelocation = ['/data/',dataname,'.mat'];
load(filelocation);
data.X1 = X1;
data.X2 = X2;
data.Y = label;

% numPair indicates the num of side information
params.numPair = 5000;
params.numIter = 50;   % number of iteration for projected gradient descent
etaInitial = 1e-4;
params.eta1 = etaInitial;
params.eta2 = etaInitial;
clear 'X1' 'X2' 'label' 'filelocation' 'etaInitial'

% regularization parameters candidate list needed to tune
C1_list = [200,20];
C2_list = [20,2];

% performance = [Fscore,Precision,Recall,NMI,AR,Entropy]
[perf_mean, perf_var] = MVMC_tune(data, C1_list, C2_list, params);
perf_var(:,1:2) = perf_mean(:,1:2);
